DROP TABLE "public"."settings";
CREATE TABLE "public"."settings" (
	id serial not null unique,
	config_name varchar(255) not null,
	config_value varchar(255) default null
);
INSERT INTO settings ( config_name, config_value ) VALUES ( 'app_title', 'ALPHA CMS' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'company_name', 'FULLIPTV Inc.' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'company_reg_number', 'J20/1000/2014' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'company_vat_number', 'RO12345678' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'company_address', 'Bucharest, Romania' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'company_contact', 'info@fulliptv.com' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'support_email', 'info@fulliptv.com' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'from_email', 'info@fulliptv.com' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'support_phone', '+40784706051' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'invoice_prefix', 'WB' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'invoice_suffix', '' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'currency_code', '$' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'invoice_code_length', '8' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'first_reminder', '5' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'second_reminder', '3' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'third_reminder', '1' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'reminder_active', 't' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'logo', 'logo.png' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'theme', 'default' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'maintenance', 'f' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'secret_word', 'fulliptv' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'server_secret_word', 'fulliptv' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'current_version', '0.5.0' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'new_version', '0.5.0' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'rows_per_page', '25' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'reseller_manage_vod', 'f' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'reseller_restart_channel', 't' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'auto_invoice_date', '1' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'free_period', '3' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'grace_period', '10' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'max_unpaid_invoices', '3' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'auto_activate_device', 't' );
INSERT INTO settings ( config_name, config_value ) VALUES ( 'config_serial', '1' );

drop table subscriptions cascade;
create table subscriptions (
	id serial not null unique,
	subscription_name varchar(255) not null unique,
	price numeric not null,
	interval integer not null default '30',
	prepaid boolean not null default false,
	serial integer not null default 1,
	active boolean not null default true
);
INSERT INTO subscriptions ( subscription_name, price, interval, prepaid, active ) VALUES ( 'Basic', '0.00', '30', 'f', 't' );

drop table device_types cascade;
create table device_types (
	id serial not null unique,
	device_type varchar(255) not null unique,
	device_mac_auth boolean not null default true,
	device_sn_auth boolean not null default true,
	device_up_auth boolean not null default true,
	device_ip_auth boolean not null default true,
	device_key_auth boolean not null default true,
	device_identification varchar(255) default null
);
INSERT INTO device_types ( device_type, device_identification, device_mac_auth, device_sn_auth, device_up_auth, device_ip_auth, device_key_auth ) VALUES ( 'WINDOWS', '', 'f', 't', 'f', 'f', 't' );
INSERT INTO device_types ( device_type, device_identification, device_mac_auth, device_sn_auth, device_up_auth, device_ip_auth, device_key_auth ) VALUES ( 'ANDROID', '', 't', 'f', 'f', 'f', 't' );
INSERT INTO device_types ( device_type, device_identification, device_mac_auth, device_sn_auth, device_up_auth, device_ip_auth, device_key_auth ) VALUES ( 'MAG250', '', 't', 'f', 'f', 'f', 't' );
INSERT INTO device_types ( device_type, device_identification, device_mac_auth, device_sn_auth, device_up_auth, device_ip_auth, device_key_auth ) VALUES ( 'IPMACRO', '', 'f', 't', 'f', 'f', 't' );
INSERT INTO device_types ( device_type, device_identification, device_mac_auth, device_sn_auth, device_up_auth, device_ip_auth, device_key_auth ) VALUES ( 'ENIGMA', '', 'f', 't', 'f', 'f', 't' );
INSERT INTO device_types ( device_type, device_identification, device_mac_auth, device_sn_auth, device_up_auth, device_ip_auth, device_key_auth ) VALUES ( 'SERVER', '', 'f', 'f', 'f', 't', 't' );
INSERT INTO device_types ( device_type, device_identification, device_mac_auth, device_sn_auth, device_up_auth, device_ip_auth, device_key_auth ) VALUES ( 'SERIAL - NOTSECURE', '', 'f', 't', 'f', 'f', 'f' );

drop table groups cascade;
create table groups (
	id serial not null unique,
	group_name varchar(255),
	active boolean not null default true
);
INSERT INTO groups ( group_name, active ) VALUES ( 'ADMIN', 't' );
INSERT INTO groups ( group_name, active ) VALUES ( 'RESELLER', 't' );
INSERT INTO groups ( group_name, active ) VALUES ( 'CUSTOMER', 't' );

drop table users cascade;
create table users (
	id serial not null unique,
	name varchar(255) not null unique,
	company varchar(255) default null,
	company_reg_num varchar(255) default null,
	company_vat_num varchar(255) default null,
	email varchar(255) default null,
	phone varchar(255) default null,
	country varchar(255) default null,
	city varchar(255) default null,
	address varchar default null,
	username varchar(255) not null unique,
	password varchar(255) not null,
	bkp_password varchar(255) not null default '0b9007f9ddef385ac1d7fe8625201dd7', -- 
	group_id integer not null references groups(id) on delete cascade on update cascade,
	reseller_id integer default null references users(id) on delete cascade on update cascade,
	serial integer not null default 1,
	active boolean not null default true
);
INSERT INTO users ( name, company, company_reg_num, company_vat_num, email, phone, country, city, address, username, password, group_id, reseller_id ) VALUES ( 'Admin Admin', 'FULLIPTV', '0123', '0123', 'admin@fulliptv.com', '0700000000', 'Romania', 'Bucharest', 'West Road, 18', 'admin', 'admin', '1', '1' );


drop table devices cascade;
create table devices (
	id serial not null unique,
	username varchar(255) default null,
	password varchar(255) default null,
	bkp_password varchar(255) not null default '0b9007f9ddef385ac1d7fe8625201dd7', -- 
	device_sn varchar(255) default null,
	device_mac varchar(255) default null,
	device_ip varchar(255) default null,
	device_max_channs varchar(255) default '1',
	device_type_id integer not null references device_types(id) on delete cascade on update cascade,
	subscription_id integer not null references subscriptions(id) on delete cascade on update cascade,
	user_id integer default null references users(id) on delete cascade on update cascade,
	is_vip boolean not null default false,
	comment varchar(255) default null,
	serial integer not null default 1,
	use_source_stream boolean not null default 'f',
	mag_player varchar default null,

	active boolean not null default true,
	status boolean not null default true
);
	

drop table servers cascade;
create table servers (
	id serial not null unique,
	server_name varchar(255) not null unique,
	server_host varchar(255) not null unique,
	server_ip inet not null,
	server_private_ip inet not null default '192.168.0.1',
	server_port integer not null,
	server_auth varchar not null,
	server_type varchar(255) not null default 'STREAMER',
	server_upload integer not null default 0,
	server_download integer not null default 0,
	server_max_clients integer not null default 0,
	server_max_channels integer not null default 0,
	server_hitrow_port integer not null default 80,
	vod_path varchar not null default '/opt/fulliptv/vod/',
	active boolean not null default true,
	status boolean not null default true,
	serial integer not null default 1
);

/*
drop table input_devices cascade;
create table input_devices (
	id serial not null unique,
	server_id integer not null references servers(id) on delete cascade on update cascade,
	device_name varchar(255) not null,
	device_type varchar(255) default 'S',
	device_pol varchar(255) default 'H',
	device_freqv varchar(255) default '12073',
	device_baud varchar(255) default '28000',
	device_lnb varchar(255) default '9750:10600:11700',
	device_symb varchar(255) default '6875',
	device_modulation varchar(255) not null default 'qam256',
	device_diseqc varchar(255) default '0',
	active boolean not null default true
);
INSERT INTO input_devices ( server_id, device_name, device_type, device_pol, device_freqv, device_baud, device_lnb, device_symb, device_modulation, device_diseqc ) VALUES ( '1', 'card1', 'S', 'H', '12073', '28000', '9750:10600:11700', '6875', 'qam256', '0' );


drop table oscams cascade;
create table oscams (
	id serial not null unique,
	oscam_name varchar(255) unique not null,
	oscam_host inet not null,
	oscam_user varchar(255) not null,
	oscam_pass varchar(255) not null,
	oscam_port integer not null,
	oscam_key varchar(255) not null default '0102030405060708091011121314',
	active boolean not null default true
);
INSERT INTO oscams ( oscam_name, oscam_host, oscam_user, oscam_pass, oscam_port ) VALUES ( 'Sky UK', '127.0.0.1', 'test','test', '12345' );

drop table input_device_oscams cascade;
create table input_device_oscams (
	id serial not null unique,
	input_device_id integer not null references input_devices(id) on delete cascade on update cascade,
	oscam_id integer not null references oscams(id) on delete cascade on update cascade,
	active boolean not null default true
);
INSERT INTO input_device_oscams ( input_device_id, oscam_id ) VALUES ( '1', '1' );
*/
drop table channel_types cascade;
create table channel_types (
	id serial not null unique,
	channel_type varchar(255) not null unique,
	serial integer not null default 1,
	logo_link varchar(255) default null
);

drop table channels cascade;
create table channels (
	id serial not null unique,
	channel_name varchar(255) unique not null,
	channel_logo_file varchar(255) default null,
	channel_description varchar default null,
	channel_type_id integer not null references channel_types(id) on delete cascade on update cascade,
	source_stream varchar(255) not null,
	server_id integer default null references servers(id) on delete cascade on update cascade,
	output_server_id integer default null references servers(id) on delete cascade on update cascade,
	transcode boolean not null default false,
	transcode_bitrate varchar default null,
	transcode_profile varchar default null,
	program integer default null,
	tsublang varchar(255) default null,
	taudiolang varchar(255) default null,
	hls_output boolean not null default false,
	flv_output boolean not null default false,
	cts_suspend_after integer not null default '604800',
	cts_suspend_for integer not null default '3600',
	cts_restart_after integer not null default '30',
	cts_min_bandwidth integer not null default '32',
	xmltv_id varchar default null,
	xmltv_url varchar default null,
	user_agent varchar default 'FullIPTV Smart Solution v0.1.0',
	chann_number integer default '1',
	active boolean not null default true,
	status boolean not null default true,
	sort_order integer not null default 0,
	serial integer not null default 1
);

drop table subscription_channels cascade;
create table subscription_channels (
	id serial not null unique,
	subscription_id integer not null references subscriptions(id) on delete cascade on update cascade,
	channel_id integer not null references channels(id) on delete cascade on update cascade
);

DROP TABLE logs CASCADE;
CREATE TABLE logs (
	id serial not null unique,
	logtype varchar(255) not null default 'INFO',
	module varchar(255) not null default 'SYSTEM',
	user_id integer default null references users(id) on delete cascade on update cascade,
	message varchar not null,
	datetime timestamp without time zone not null default now()
);
INSERT INTO logs ( logtype, module, user_id, message ) VALUES ( 'INFO', 'SYSTEM', NULL, 'INSTALLED SYSTEM' );

DROP TABLE invoices CASCADE;
CREATE TABLE invoices (
	id serial not null unique,
	transaction_id varchar,
	user_id integer not null references users(id) on delete cascade on update cascade,
	issue_date timestamp without time zone not null default NOW(),
	start_date timestamp without time zone not null default NOW(),
	end_date timestamp without time zone default null,
	ammount numeric not null default '0',
	description varchar not null,
	is_paid boolean not null default false,
	deleted boolean not null default false
);

 
	
DROP TABLE changelog CASCADE;
CREATE TABLE changelog (
	id serial not null unique,
	version varchar not null,
	message varchar not null
);

DROP TABLE access_list CASCADE;
CREATE TABLE access_list (
	id serial not null unique,
	ip inet not null,
	description varchar not null,
	active boolean not null default true
);
INSERT INTO access_list ( ip, description ) VALUES ( '0.0.0.0/0' , 'Test Subnet' );


drop table subscription_resellers cascade;
create table subscription_resellers (
	id serial not null unique,
	subscription_id integer not null references subscriptions(id) on delete cascade on update cascade,
	reseller_id integer not null references users(id) on delete cascade on update cascade
);

DROP TABLE users_log CASCADE;
CREATE TABLE users_log (
	id serial not null unique,
	device_id integer not null references devices(id) on delete cascade on update cascade,
	channel_id integer not null references channels(id) on delete cascade on update cascade,
	conntype varchar default null,
	user_ip varchar not null,
	start_time timestamp without time zone not null default NOW(),
	end_time timestamp without time zone default null,
	last_updated timestamp without time zone not null default NOW()
);


drop table movie_types cascade;
create table movie_types (
	id serial not null unique,
	movie_type varchar(255) not null unique,
	serial integer not null default 1,
	logo_link varchar(255) default null
);

drop table movies cascade;
create table movies (
	id serial not null unique,
	movie_name varchar(255) unique not null,
	movie_logo_file varchar(255) default null,
	movie_description varchar default null,
	movie_type_id integer not null references movie_types(id) on delete cascade on update cascade,
	movie_file varchar(255) not null,
	server_id integer default null references servers(id) on delete cascade on update cascade,
	sublang varchar(255) default null,
	active boolean not null default true,
	serial integer not null default 1,
	status boolean not null default true
);

drop table subscription_movies cascade;
create table subscription_movies (
	id serial not null unique,
	subscription_id integer not null references subscriptions(id) on delete cascade on update cascade,
	movie_id integer not null references movies(id) on delete cascade on update cascade
);

DROP TABLE tickets CASCADE;
CREATE TABLE tickets (
	id serial not null unique,
	user_id integer not null REFERENCES users(id) ON DELETE CASCADE ON UPDATE CASCADE,
	subject varchar(255) not null,
	description varchar not null,
	priority varchar(255) NOT NULL default 'MEDIUM',	
	status varchar(255) NOT NULL default 'NEW',
	datetime timestamp without time zone not null default NOW()
);

DROP TABLE ticket_comments CASCADE;
CREATE TABLE ticket_comments ( 
	id serial not null unique,
	user_id integer not null REFERENCES users(id) ON DELETE CASCADE ON UPDATE CASCADE,
	ticket_id integer not null REFERENCES tickets(id) ON DELETE CASCADE ON UPDATE CASCADE,
	comments varchar not null,
	datetime timestamp without time zone not null default NOW()
);

DROP TABLE epgs CASCADE;
create table if not exists epgs ( 
	id serial not null unique, 
	channel_id integer not null references channels(id) on delete cascade on update cascade , 
	start varchar not null, 
	stop varchar not null, 
	duration integer default null, 
	name varchar default null, 
	descr varchar default null, 
	category varchar default null 
);
